Skip to main content Skip to footer

Editing Nested FlexSheet Group Rows in JavaScript

Background

FlexSheet can display hierarchical data by creating a Wijmo FlexGrid with childItemsPath, then using that grid as the source for a FlexSheet Sheet.

When childItemsPath is used, parent rows are rendered as tree/group rows. These rows are read-only by default, so users can edit child rows but not parent rows unless the row-level read-only setting is cleared.

This article shows how to display nested rows in a JavaScript FlexSheet, allow editing on parent/group rows, preserve formula display behavior, and optionally update child rows when a parent row value changes.

Steps to Complete

  1. Install and import the required Wijmo packages.
  2. Add the FlexSheet host element and row insertion buttons.
  3. Initialize the FlexSheet.
  4. Create a FlexGrid-backed sheet with childItemsPath.
  5. Make tree/group rows editable.
  6. Display formula results when cells are not being edited.
  7. Optionally cascade parent row edits to child rows.
  8. Add helper methods for inserting rows.
  9. Add sample data and styles.

Getting Started

Install and import the required Wijmo packages

npm install @mescius/wijmo @mescius/wijmo.grid @mescius/wijmo.grid.sheet @mescius/wijmo.styles
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';

import * as wjGrid from '@mescius/wijmo.grid';
import * as wjSheet from '@mescius/wijmo.grid.sheet';
  • The wijmo.grid.sheet package provides the FlexSheet and Sheet classes. The wijmo.grid package is used to create the backing FlexGrid.

 

Add the FlexSheet host element and row insertion buttons

<div class="container-fluid">
  <div class="toolbar">
    <button id="addAbove" type="button">Add above</button>
    <button id="addBelow" type="button">Add below</button>
    <button id="addChild" type="button">Add child</button>
  </div>

  <div id="flexSheet"></div>
</div>
  • The #flexSheet element is the host element where the JavaScript FlexSheet control will be created.

 

Initialize the FlexSheet

let flexSheet;
const data = getSampleData();
const childItemsPath = ['checks', 'earnings', 'earnings'];

document.readyState === 'complete' ? init() : window.onload = init;

function init() {
  flexSheet = new wjSheet.FlexSheet('#flexSheet');
  flexSheet.autoGenerateColumns = false;

  updateFactoryFnToShowFormulaResult(flexSheet);
  addCascadeEditHandler(flexSheet);
  addFlexSheetEventHandlers(flexSheet);
  createTreeGridSheet(flexSheet);

  flexSheet.collapseGroupsToLevel(0);

  document.getElementById('addAbove').addEventListener('click', () => {
    insertItem('above');
  });

  document.getElementById('addBelow').addEventListener('click', () => {
    insertItem('below');
  });

  document.getElementById('addChild').addEventListener('click', () => {
    insertItem('child');
  });
}
  • This creates the FlexSheet directly in JavaScript and wires up the buttons for row insertion.

 

Create a FlexGrid-backed sheet with childItemsPath

function createTreeGridSheet(sheet) {
  const grid = new wjGrid.FlexGrid(document.createElement('div'), {
    childItemsPath,
    autoGenerateColumns: false,
    columns: [
      { binding: 'name' },
      { binding: 'hours', dataType: 'Number', format: 'n2' },
      { binding: 'rate', dataType: 'Number', format: 'n2' }
    ],
    itemsSource: data
  });

  const treeSheet = new wjSheet.Sheet(sheet, grid, 'TreeGridSheet');
  sheet.sheets.push(treeSheet);
}
  • Instead of using addBoundSheet, create a FlexGrid with hierarchical data and pass it to the Sheet constructor. This allows FlexSheet to display nested rows using childItemsPath.

 

Make tree/group rows editable

function addFlexSheetEventHandlers(sheet) {
  sheet.loadedRows.addHandler((s) => {
    const activeSheet = s.selectedSheet;

    if (activeSheet && activeSheet.grid && activeSheet.grid.childItemsPath) {
      s.rows.forEach((row) => {
        row.isReadOnly = false;
      });
    }
  });

  sheet.selectedSheetChanged.addHandler((s) => {
    const activeSheet = s.selectedSheet;

    if (activeSheet && activeSheet.grid) {
      s.childItemsPath = activeSheet.grid.childItemsPath;
    }

    if (activeSheet && activeSheet._collapseInfo) {
      s.rows.forEach((row) => {
        row.isCollapsed = !activeSheet._collapseInfo.has(row.index);
      });
    }
  });

  sheet.groupCollapsedChanged.addHandler((s, e) => {
    const activeSheet = s.selectedSheet;

    if (!activeSheet._collapseInfo) {
      activeSheet._collapseInfo = new Set();
    }

    if (s.rows[e.row].isCollapsed) {
      activeSheet._collapseInfo.delete(e.row);
    } else {
      activeSheet._collapseInfo.add(e.row);
    }
  });
}
  • The loadedRows handler is the key piece. It sets row.isReadOnly = false, allowing users to edit parent/group rows in the FlexSheet.
  • The other handlers preserve the nested row configuration and collapsed state when sheets are changed.

 

Display formula results when cells are not being edited

function updateFactoryFnToShowFormulaResult(sheet) {
  const oldFn = sheet.cellFactory.updateCell;

  sheet.cellFactory.updateCell = function(panel, r, c, cell, rng) {
    oldFn.call(this, panel, r, c, cell, rng);

    if (panel.cellType !== wjGrid.CellType.Cell) {
      return;
    }

    const grid = panel.grid;

    if (rng && !rng.isSingleCell) {
      r = rng.row;
      c = rng.col;
    }

    if (
      grid.editRange &&
      grid.editRange.containsRow(r) &&
      grid.editRange.containsColumn(c)
    ) {
      return;
    }

    const cellData = grid.getCellData(r, c, true);

    if (typeof cellData === 'string' && cellData.startsWith('=')) {
      cell.innerText = grid.getCellValue(r, c, true);
    }
  };
}
  • This keeps formulas editable while showing the calculated result when the cell is not actively being edited.

 

Optionally cascade parent row edits to child rows

function addCascadeEditHandler(sheet) {
  const bindingsToCascade = new Set(['hours', 'rate']);

  sheet.cellEditEnded.addHandler((s, e) => {
    const row = s.rows[e.row];
    const col = s.columns[e.col];
    const binding = col.binding;

    if (!row || !row.hasChildren || !bindingsToCascade.has(binding)) {
      return;
    }

    const value = row.dataItem[binding];

    updateChildren(
      row.dataItem,
      row.level,
      s.childItemsPath,
      binding,
      value
    );

    s.collectionView.refresh();
  });
}

function updateChildren(item, level, paths, binding, value) {
  const childPath = paths[Math.min(level, paths.length - 1)];
  const children = item[childPath];

  if (!Array.isArray(children)) {
    return;
  }

  children.forEach((child) => {
    child[binding] = value;
    updateChildren(child, level + 1, paths, binding, value);
  });
}
  • Use this when a parent row edit should push the edited value down to its descendants. In this example, edits to hours and rate are cascaded.

 

Add helper methods for inserting rows

function insertItem(mode) {
  if (!flexSheet) {
    return;
  }

  insertItemAtIndex(
    flexSheet,
    flexSheet.selection.row,
    mode,
    { name: 'newItem', hours: 5, rate: 5 }
  );
}

function insertItemAtIndex(grid, index, mode, newItem) {
  const row = grid.rows[index];

  if (!row) {
    return;
  }

  if (mode === 'child') {
    const item = row.dataItem;
    const binding = grid.childItemsPath[
      Math.min(row.level, grid.childItemsPath.length - 1)
    ];

    if (!Array.isArray(item[binding])) {
      item[binding] = [];
    }

    item[binding].unshift(newItem);
  } else {
    const parentCollection = getParentCollection(grid, row.index);
    const itemIndex = parentCollection.indexOf(row.dataItem);
    const delta = mode === 'above' ? 0 : 1;

    parentCollection.splice(itemIndex + delta, 0, newItem);
  }

  grid.collectionView.refresh();
}

function getParentCollection(grid, rowIndex) {
  const row = grid.rows[rowIndex];

  if (row.level === 0) {
    return grid.collectionView.sourceCollection;
  }

  for (let r = rowIndex - 1; r >= 0; r--) {
    const parentRow = grid.rows[r];

    if (parentRow.hasChildren && parentRow.level < row.level) {
      return parentRow.dataItem[grid.childItemsPath[parentRow.level]];
    }
  }

  return grid.collectionView.sourceCollection;
}
  • These helpers allow users to add rows above, below, or as children of the selected row while keeping the nested source collection synchronized.

 

Add sample data and styles

function getSampleData() {
  return [
    {
      name: 'Jack Smith',
      checks: [
        {
          name: 'check1',
          earnings: [
            { name: 'hourly', hours: 30, rate: 15 },
            { name: 'overtime', hours: 10, rate: 20 },
            { name: 'bonus', hours: 5, rate: 30 }
          ]
        },
        {
          name: 'check2',
          earnings: [
            { name: 'hourly', hours: 20, rate: 18 },
            { name: 'overtime', hours: 20, rate: 24 }
          ]
        }
      ]
    }
  ];
}
.toolbar {
  margin-bottom: 8px;
}

.toolbar button {
  margin-right: 6px;
}

.wj-flexsheet {
  height: 500px;
}

.wj-grouppanel .wj-remove {
  display: none;
}

 

With this setup, a JavaScript FlexSheet can display nested data, allow edits on group rows, preserve formula display behavior, and update child rows from parent edits when needed.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Editing Nested FlexSheet Group Rows in React

Background

FlexSheet can display hierarchical data by creating a Wijmo FlexGrid with childItemsPath and then using that grid as the source for a FlexSheet Sheet.

In this scenario, parent rows are rendered as tree/group rows. These rows are read-only by default, so users can edit child rows but not the main parent rows. To allow editing on those parent rows, you can clear the row-level read-only setting after the rows are loaded.

You can also preserve formula display behavior by customizing the FlexSheet cell factory so formulas show their calculated results when the cell is not being edited.

Steps to Complete

  1. Install and import the required Wijmo React packages.
  2. Create nested hierarchical data.
  3. Initialize the FlexSheet and enable editing for tree/group rows.
  4. Create a FlexGrid-backed sheet with childItemsPath.
  5. Display formula results when cells are not being edited.
  6. Optionally cascade parent row edits to child rows.
  7. Add row insertion helpers.
  8. Add buttons for inserting rows.

Getting Started

Install and import the required Wijmo React packages

npm install @mescius/wijmo.react.grid.sheet @mescius/wijmo.grid @mescius/wijmo.grid.sheet @mescius/wijmo.styles
import React, { useCallback, useMemo, useRef } from 'react';
import '@mescius/wijmo.styles/wijmo.css';

import { FlexSheet } from '@mescius/wijmo.react.grid.sheet';
import * as wjGrid from '@mescius/wijmo.grid';
import * as wjSheet from '@mescius/wijmo.grid.sheet';

import './styles.css';
  • The wijmo.react.grid.sheet package provides the React FlexSheet component. The wijmo.grid and wijmo.grid.sheet packages are used to create the backing FlexGrid and attach it to the FlexSheet as a sheet.

 

Create nested hierarchical data

function getSampleData() {
  return [
    {
      name: 'Jack Smith',
      checks: [
        {
          name: 'check1',
          earnings: [
            { name: 'hourly', hours: 30, rate: 15 },
            { name: 'overtime', hours: 10, rate: 20 },
            { name: 'bonus', hours: 5, rate: 30 }
          ]
        },
        {
          name: 'check2',
          earnings: [
            { name: 'hourly', hours: 20, rate: 18 },
            { name: 'overtime', hours: 20, rate: 24 }
          ]
        }
      ]
    }
  ];
}
  • Each parent item contains child arrays. In this example, workers contain checks, and each check contains earnings.

 

Initialize the FlexSheet and enable editing for tree/group rows

const childItemsPath = ['checks', 'earnings', 'earnings'];

function App() {
  const flexSheetRef = useRef(null);
  const data = useMemo(() => getSampleData(), []);

  const initialized = useCallback((flexSheet) => {
    flexSheetRef.current = flexSheet;
    flexSheet.autoGenerateColumns = false;

    updateFactoryFnToShowFormulaResult(flexSheet);

    flexSheet.loadedRows.addHandler((s) => {
      const activeSheet = s.selectedSheet;

      if (activeSheet && activeSheet.grid && activeSheet.grid.childItemsPath) {
        s.rows.forEach((row) => {
          row.isReadOnly = false;
        });
      }
    });

    flexSheet.selectedSheetChanged.addHandler((s) => {
      const activeSheet = s.selectedSheet;

      if (activeSheet && activeSheet.grid) {
        s.childItemsPath = activeSheet.grid.childItemsPath;
      }

      if (activeSheet && activeSheet._collapseInfo) {
        const info = activeSheet._collapseInfo;

        s.rows.forEach((row) => {
          row.isCollapsed = !info.has(row.index);
        });
      }
    });

    flexSheet.groupCollapsedChanged.addHandler((s, e) => {
      let info = s.selectedSheet._collapseInfo;

      if (!info) {
        info = s.selectedSheet._collapseInfo = new Set();
      }

      if (s.rows[e.row].isCollapsed) {
        info.delete(e.row);
      } else {
        info.add(e.row);
      }
    });

    createTreeGridSheet(flexSheet, data);
    flexSheet.collapseGroupsToLevel(0);
  }, [data]);

  return (
    <div className="container-fluid">
      <FlexSheet initialized={initialized} />
    </div>
  );
}
  • The loadedRows handler makes the tree/group rows editable. The selectedSheetChanged and groupCollapsedChanged handlers preserve the nested row configuration and collapsed state when switching sheets.

 

Create a FlexGrid-backed sheet with childItemsPath

function createTreeGridSheet(flexSheet, data) {
  const grid = new wjGrid.FlexGrid(document.createElement('div'), {
    childItemsPath,
    autoGenerateColumns: false,
    columns: [
      { binding: 'name' },
      { binding: 'hours', dataType: 'Number', format: 'n2' },
      { binding: 'rate', dataType: 'Number', format: 'n2' }
    ],
    itemsSource: data
  });

  const sheet = new wjSheet.Sheet(flexSheet, grid, 'TreeGridSheet');

  flexSheet.sheets.push(sheet);
}
  • Instead of using addBoundSheet, create a FlexGrid with the nested itemsSource and childItemsPath, then create a Sheet from that grid. This lets FlexSheet display the nested structure while still supporting spreadsheet behavior.

 

Display formula results when cells are not being edited

function updateFactoryFnToShowFormulaResult(flexSheet) {
  const oldFn = flexSheet.cellFactory.updateCell;

  flexSheet.cellFactory.updateCell = function(panel, r, c, cell, rng) {
    oldFn.call(this, panel, r, c, cell, rng);

    if (panel.cellType !== wjGrid.CellType.Cell) {
      return;
    }

    const grid = panel.grid;

    if (rng && !rng.isSingleCell) {
      r = rng.row;
      c = rng.col;
    }

    if (
      grid.editRange &&
      grid.editRange.containsRow(r) &&
      grid.editRange.containsColumn(c)
    ) {
      return;
    }

    const data = grid.getCellData(r, c, true);

    if (typeof data === 'string' && data.startsWith('=')) {
      cell.innerText = grid.getCellValue(r, c, true);
    }
  };
}
  • This keeps formulas editable while showing the calculated value when the cell is not in edit mode.

 

Optionally cascade parent row edits to child rows

function addCascadeEditHandler(flexSheet) {
  const bindingsToCascade = new Set(['hours', 'rate']);

  flexSheet.cellEditEnded.addHandler((s, e) => {
    const row = s.rows[e.row];
    const col = s.columns[e.col];
    const binding = col.binding;

    if (!row || !row.hasChildren || !bindingsToCascade.has(binding)) {
      return;
    }

    const value = row.dataItem[binding];

    updateChildren(row.dataItem, row.level, s.childItemsPath, binding, value);
    s.collectionView.refresh();
  });
}

function updateChildren(item, level, childItemsPath, binding, value) {
  const childPath = childItemsPath[Math.min(level, childItemsPath.length - 1)];
  const children = item[childPath];

  if (!Array.isArray(children)) {
    return;
  }

  children.forEach((child) => {
    child[binding] = value;
    updateChildren(child, level + 1, childItemsPath, binding, value);
  });
}
  • Use this step only when editing a parent row should update its child rows. In this example, edits to hours and rate cascade to descendants.
  • Call this helper from the initialized callback

Add row insertion helpers

function insertItemAtIndex(grid, index, mode, newItem) {
  const row = grid.rows[index];

  if (!row) {
    return;
  }

  if (mode === 'child') {
    const item = row.dataItem;
    const binding = grid.childItemsPath[
      Math.min(row.level, grid.childItemsPath.length - 1)
    ];

    if (!item[binding]) {
      item[binding] = [];
    }

    item[binding].unshift(newItem);
  } else {
    const parentCollection = getParentCollection(grid, row.index);
    const rowIndex = parentCollection.indexOf(row.dataItem);
    const delta = mode === 'above' ? 0 : 1;

    parentCollection.splice(rowIndex + delta, 0, newItem);
  }

  grid.collectionView.refresh();
}

function getParentCollection(grid, rowIndex) {
  const row = grid.rows[rowIndex];

  if (row.level === 0) {
    return grid.collectionView.sourceCollection;
  }

  for (let r = rowIndex - 1; r >= 0; r--) {
    const parentRow = grid.rows[r];

    if (parentRow.hasChildren && parentRow.level < row.level) {
      return parentRow.dataItem[grid.childItemsPath[parentRow.level]];
    }
  }

  return grid.collectionView.sourceCollection;
}
  • These helpers allow users to add rows above, below, or as children of the selected row while keeping the nested source data in sync.

 

Add buttons for inserting rows

function App() {
  const flexSheetRef = useRef(null);
  const data = useMemo(() => getSampleData(), []);

  const insertItem = useCallback((mode) => {
    const flexSheet = flexSheetRef.current;

    if (!flexSheet) {
      return;
    }

    insertItemAtIndex(
      flexSheet,
      flexSheet.selection.row,
      mode,
      { name: 'newItem', hours: 5, rate: 5 }
    );
  }, []);

  return (
    <div className="container-fluid">
      <div>
        <button onClick={() => insertItem('above')}>Add above</button>
        <button onClick={() => insertItem('below')}>Add below</button>
        <button onClick={() => insertItem('child')}>Add child</button>
      </div>

      <FlexSheet initialized={initialized} />
    </div>
  );
}
  • The buttons call the insertion helper using the currently selected FlexSheet row.

 

With this setup, FlexSheet can display nested hierarchical rows, allow editing on parent/group rows, preserve formula display behavior, and optionally cascade parent row edits to child rows.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Editing Nested FlexSheet Group Rows in Angular

Background

FlexSheet can display hierarchical data by creating a Wijmo FlexGrid with childItemsPath, then using that grid as the source for a FlexSheet Sheet.

When childItemsPath is used, the rows are rendered as tree/group rows. These rows are read-only by default, so users can edit child rows but not the parent rows unless you explicitly make the rows editable.

Steps to Complete

  1. Install and import the Wijmo Angular FlexSheet modules.
  2. Add the FlexSheet markup and row insertion buttons.
  3. Initialize the FlexSheet and make tree/group rows editable.
  4. Create a FlexGrid-backed sheet with childItemsPath.
  5. Display formula results when cells are not being edited.
  6. Optionally cascade parent row edits to child rows.
  7. Add helper methods for inserting rows.
  8. Add sample data and styles.

Getting Started

Install and import the Wijmo Angular FlexSheet modules

npm install @mescius/wijmo @mescius/wijmo.grid @mescius/wijmo.grid.sheet @mescius/wijmo.angular2.grid.sheet @mescius/wijmo.styles
import { Component } from '@angular/core';
import { WjGridSheetModule } from '@mescius/wijmo.angular2.grid.sheet';

import * as wjGrid from '@mescius/wijmo.grid';
import * as wjSheet from '@mescius/wijmo.grid.sheet';

import '@mescius/wijmo.styles/wijmo.css';
import './app.component.css';
  • The WjGridSheetModule package provides Angular support for the <wj-flex-sheet> component. The wjGrid and wjSheet imports are used to create the backing FlexGrid and add it to the FlexSheet.

 

Add the FlexSheet markup and row insertion buttons

<div class="container-fluid">
  <div class="toolbar">
    <button type="button" (click)="insertItem('above')">Add above</button>
    <button type="button" (click)="insertItem('below')">Add below</button>
    <button type="button" (click)="insertItem('child')">Add child</button>
  </div>

  <wj-flex-sheet
    #flex
    (initialized)="initializeFlexSheet(flex)">
  </wj-flex-sheet>
</div>
  • The initialized event gives access to the FlexSheet instance so it can be configured in code.

 

Initialize the FlexSheet and make tree/group rows editable

@Component({
  standalone: true,
  imports: [WjGridSheetModule],
  selector: 'app-component',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  private flexSheet: wjSheet.FlexSheet | null = null;

  data = getSampleData();
  childItemsPath = ['checks', 'earnings', 'earnings'];

  initializeFlexSheet(flexSheet: wjSheet.FlexSheet): void {
    this.flexSheet = flexSheet;
    flexSheet.autoGenerateColumns = false;

    this.updateFactoryFnToShowFormulaResult(flexSheet);
    this.addCascadeEditHandler(flexSheet);

    flexSheet.loadedRows.addHandler((s) => {
      const activeSheet = s.selectedSheet as TreeSheet;

      if (activeSheet?.grid?.childItemsPath) {
        s.rows.forEach((row) => {
          row.isReadOnly = false;
        });
      }
    });

    flexSheet.selectedSheetChanged.addHandler((s) => {
      const activeSheet = s.selectedSheet as TreeSheet;

      if (activeSheet?.grid) {
        s.childItemsPath = activeSheet.grid.childItemsPath;
      }

      if (activeSheet?._collapseInfo) {
        s.rows.forEach((row) => {
          row.isCollapsed = !activeSheet._collapseInfo!.has(row.index);
        });
      }
    });

    flexSheet.groupCollapsedChanged.addHandler((s, e) => {
      const activeSheet = s.selectedSheet as TreeSheet;

      if (!activeSheet._collapseInfo) {
        activeSheet._collapseInfo = new Set<number>();
      }

      if (s.rows[e.row].isCollapsed) {
        activeSheet._collapseInfo.delete(e.row);
      } else {
        activeSheet._collapseInfo.add(e.row);
      }
    });

    this.createTreeGridSheet(flexSheet);
    flexSheet.collapseGroupsToLevel(0);
  }
}
  • The key part is the loadedRows handler. It sets row.isReadOnly = false, allowing users to edit parent/group rows in the FlexSheet.

 

Create a FlexGrid-backed sheet with childItemsPath

type TreeSheet = wjSheet.Sheet & {
  grid?: wjGrid.FlexGrid;
  _collapseInfo?: Set<number>;
};

private createTreeGridSheet(flexSheet: wjSheet.FlexSheet): void {
  const grid = new wjGrid.FlexGrid(document.createElement('div'), {
    childItemsPath: this.childItemsPath,
    autoGenerateColumns: false,
    columns: [
      { binding: 'name' },
      { binding: 'hours', dataType: 'Number', format: 'n2' },
      { binding: 'rate', dataType: 'Number', format: 'n2' }
    ],
    itemsSource: this.data
  });

  const sheet = new wjSheet.Sheet(flexSheet, grid, 'TreeGridSheet');
  flexSheet.sheets.push(sheet);
}
  • Instead of using addBoundSheet, this creates a FlexGrid with hierarchical data and passes it to the Sheet constructor. This allows FlexSheet to display nested rows using childItemsPath.

 

Display formula results when cells are not being edited

private updateFactoryFnToShowFormulaResult(flexSheet: wjSheet.FlexSheet): void {
  const oldFn = flexSheet.cellFactory.updateCell;

  flexSheet.cellFactory.updateCell = function (
    panel: wjGrid.GridPanel,
    r: number,
    c: number,
    cell: HTMLElement,
    rng?: wjGrid.CellRange
  ): void {
    oldFn.call(this, panel, r, c, cell, rng);

    if (panel.cellType !== wjGrid.CellType.Cell) {
      return;
    }

    const sheet = panel.grid as wjSheet.FlexSheet;

    if (rng && !rng.isSingleCell) {
      r = rng.row;
      c = rng.col;
    }

    if (
      sheet.editRange &&
      sheet.editRange.containsRow(r) &&
      sheet.editRange.containsColumn(c)
    ) {
      return;
    }

    const data = sheet.getCellData(r, c, true);

    if (typeof data === 'string' && data.startsWith('=')) {
      cell.innerText = sheet.getCellValue(r, c, true);
    }
  };
}
  • This keeps formulas editable while showing the calculated result when the cell is not actively being edited.

 

Optionally cascade parent row edits to child rows

private addCascadeEditHandler(flexSheet: wjSheet.FlexSheet): void {
  const bindingsToCascade = new Set(['hours', 'rate']);

  flexSheet.cellEditEnded.addHandler((s, e) => {
    const row = s.rows[e.row];
    const col = s.columns[e.col];
    const binding = col.binding;

    if (!row || !row.hasChildren || !binding || !bindingsToCascade.has(binding)) {
      return;
    }

    const item = row.dataItem as TreeItem;
    const value = item[binding];

    updateChildren(
      item,
      row.level,
      s.childItemsPath as string[],
      binding,
      value
    );

    s.collectionView.refresh();
  });
}

function updateChildren(
  item: TreeItem,
  level: number,
  childItemsPath: string[],
  binding: string,
  value: unknown
): void {
  const childPath = childItemsPath[Math.min(level, childItemsPath.length - 1)];
  const children = item[childPath] as TreeItem[] | undefined;

  if (!Array.isArray(children)) {
    return;
  }

  children.forEach((child) => {
    child[binding] = value;
    updateChildren(child, level + 1, childItemsPath, binding, value);
  });
}
  • Use this when a parent row edit should push the edited value down to its descendants. In this example, edits to hours and rate are cascaded.

 

Add helper methods for inserting rows

type InsertMode = 'above' | 'below' | 'child';

interface TreeItem {
  name: string;
  hours?: number;
  rate?: number;
  checks?: TreeItem[];
  earnings?: TreeItem[];
  [key: string]: unknown;
}

insertItem(mode: InsertMode): void {
  if (!this.flexSheet) {
    return;
  }

  insertItemAtIndex(
    this.flexSheet,
    this.flexSheet.selection.row,
    mode,
    { name: 'newItem', hours: 5, rate: 5 }
  );
}

function insertItemAtIndex(
  grid: wjSheet.FlexSheet,
  index: number,
  mode: InsertMode,
  newItem: TreeItem
): void {
  const row = grid.rows[index];

  if (!row) {
    return;
  }

  const childItemsPath = grid.childItemsPath as string[];

  if (mode === 'child') {
    const item = row.dataItem as TreeItem;
    const binding = childItemsPath[Math.min(row.level, childItemsPath.length - 1)];

    if (!Array.isArray(item[binding])) {
      item[binding] = [];
    }

    (item[binding] as TreeItem[]).unshift(newItem);
  } else {
    const parentCollection = getParentCollection(grid, row.index);
    const rowIndex = parentCollection.indexOf(row.dataItem as TreeItem);
    const delta = mode === 'above' ? 0 : 1;

    parentCollection.splice(rowIndex + delta, 0, newItem);
  }

  grid.collectionView.refresh();
}

function getParentCollection(
  grid: wjSheet.FlexSheet,
  rowIndex: number
): TreeItem[] {
  const row = grid.rows[rowIndex];
  const childItemsPath = grid.childItemsPath as string[];

  if (row.level === 0) {
    return grid.collectionView.sourceCollection as TreeItem[];
  }

  for (let r = rowIndex - 1; r >= 0; r--) {
    const parentRow = grid.rows[r];

    if (parentRow.hasChildren && parentRow.level < row.level) {
      const parentItem = parentRow.dataItem as TreeItem;
      return parentItem[childItemsPath[parentRow.level]] as TreeItem[];
    }
  }

  return grid.collectionView.sourceCollection as TreeItem[];
}
  • These helpers allow users to add rows above, below, or as children of the selected row while keeping the nested source collection synchronized.

 

Add sample data and styles

function getSampleData(): TreeItem[] {
  return [
    {
      name: 'Jack Smith',
      checks: [
        {
          name: 'check1',
          earnings: [
            { name: 'hourly', hours: 30, rate: 15 },
            { name: 'overtime', hours: 10, rate: 20 },
            { name: 'bonus', hours: 5, rate: 30 }
          ]
        },
        {
          name: 'check2',
          earnings: [
            { name: 'hourly', hours: 20, rate: 18 },
            { name: 'overtime', hours: 20, rate: 24 }
          ]
        }
      ]
    }
  ];
}
.toolbar {
  margin-bottom: 8px;
}

.toolbar button {
  margin-right: 6px;
}

.wj-flexsheet {
  height: 500px;
}

.wj-grouppanel .wj-remove {
  display: none;
}

 

With this setup, Angular FlexSheet can display nested data, allow edits on group rows, preserve formula display behavior, and update child rows from parent edits when needed.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Editing Nested FlexSheet Group Rows in Vue

Background

FlexSheet can display hierarchical data by creating a Wijmo FlexGrid with childItemsPath, then using that grid as the source for a FlexSheet Sheet.

When childItemsPath is used, parent rows are rendered as tree/group rows. These rows are read-only by default, so users can edit child rows but not parent rows unless the row-level read-only setting is cleared.

This article shows how to display nested rows in a Vue FlexSheet, allow editing on parent/group rows, preserve formula display behavior, and optionally update child rows when a parent row value changes.

Steps to Complete

  1. Install and import the Wijmo Vue FlexSheet packages.
  2. Add the FlexSheet markup and row insertion buttons.
  3. Initialize the FlexSheet and make tree/group rows editable.
  4. Create a FlexGrid-backed sheet with childItemsPath.
  5. Display formula results when cells are not being edited.
  6. Optionally update child rows when a parent row is edited.
  7. Add row insertion helpers.
  8. Add sample data and styles.

Getting Started

Install and import the Wijmo Vue FlexSheet packages

npm install @mescius/wijmo @mescius/wijmo.grid @mescius/wijmo.grid.sheet @mescius/wijmo.vue2.grid.sheet @mescius/wijmo.styles
<script setup>
import { ref } from 'vue';

import { WjFlexSheet } from '@mescius/wijmo.vue2.grid.sheet';
import * as wjGrid from '@mescius/wijmo.grid';
import * as wjSheet from '@mescius/wijmo.grid.sheet';
</script>
  • The wijmo.vue2.grid.sheet package provides Vue components for FlexSheet.

 

Add the FlexSheet markup and row insertion buttons

<template>
  <div class="container-fluid">
    <div class="toolbar">
      <button type="button" @click="insertItem('above')">Add above</button>
      <button type="button" @click="insertItem('below')">Add below</button>
      <button type="button" @click="insertItem('child')">Add child</button>
    </div>

    <wj-flex-sheet :initialized="initializeFlexSheet" />
  </div>
</template>
  • The initialized event gives access to the FlexSheet instance so it can be configured after it is created.

 

Initialize the FlexSheet and make tree/group rows editable

const flexSheet = ref(null);
const data = ref(getSampleData());
const childItemsPath = ['checks', 'earnings', 'earnings'];

function initializeFlexSheet(flex) {
  flexSheet.value = flex;
  flex.autoGenerateColumns = false;

  updateFactoryFnToShowFormulaResult(flex);
  addCascadeEditHandler(flex);

  flex.loadedRows.addHandler((s) => {
    const activeSheet = s.selectedSheet;

    if (activeSheet && activeSheet.grid && activeSheet.grid.childItemsPath) {
      s.rows.forEach((row) => {
        row.isReadOnly = false;
      });
    }
  });

  flex.selectedSheetChanged.addHandler((s) => {
    const activeSheet = s.selectedSheet;

    if (activeSheet && activeSheet.grid) {
      s.childItemsPath = activeSheet.grid.childItemsPath;
    }

    if (activeSheet && activeSheet._collapseInfo) {
      s.rows.forEach((row) => {
        row.isCollapsed = !activeSheet._collapseInfo.has(row.index);
      });
    }
  });

  flex.groupCollapsedChanged.addHandler((s, e) => {
    const activeSheet = s.selectedSheet;

    if (!activeSheet._collapseInfo) {
      activeSheet._collapseInfo = new Set();
    }

    if (s.rows[e.row].isCollapsed) {
      activeSheet._collapseInfo.delete(e.row);
    } else {
      activeSheet._collapseInfo.add(e.row);
    }
  });

  createTreeGridSheet(flex);
  flex.collapseGroupsToLevel(0);
}
  • The important part is the loadedRows handler. It sets row.isReadOnly = false, which allows users to edit parent/group rows in the FlexSheet.

 

Create a FlexGrid-backed sheet with childItemsPath

function createTreeGridSheet(flex) {
  const grid = new wjGrid.FlexGrid(document.createElement('div'), {
    childItemsPath,
    autoGenerateColumns: false,
    columns: [
      { binding: 'name' },
      { binding: 'hours', dataType: 'Number', format: 'n2' },
      { binding: 'rate', dataType: 'Number', format: 'n2' }
    ],
    itemsSource: data.value
  });

  const sheet = new wjSheet.Sheet(flex, grid, 'TreeGridSheet');
  flex.sheets.push(sheet);
}
  • Instead of using addBoundSheet, create a FlexGrid with hierarchical data and pass it to the Sheet constructor. This allows FlexSheet to display nested rows using childItemsPath.

 

Display formula results when cells are not being edited

function updateFactoryFnToShowFormulaResult(flex) {
  const oldFn = flex.cellFactory.updateCell;

  flex.cellFactory.updateCell = function(panel, r, c, cell, rng) {
    oldFn.call(this, panel, r, c, cell, rng);

    if (panel.cellType !== wjGrid.CellType.Cell) {
      return;
    }

    const grid = panel.grid;

    if (rng && !rng.isSingleCell) {
      r = rng.row;
      c = rng.col;
    }

    if (
      grid.editRange &&
      grid.editRange.containsRow(r) &&
      grid.editRange.containsColumn(c)
    ) {
      return;
    }

    const cellData = grid.getCellData(r, c, true);

    if (typeof cellData === 'string' && cellData.startsWith('=')) {
      cell.innerText = grid.getCellValue(r, c, true);
    }
  };
}
  • This keeps formulas editable while showing the calculated value when the cell is not actively being edited.

 

Optionally update child rows when a parent row is edited

function addCascadeEditHandler(flex) {
  const bindingsToCascade = new Set(['hours', 'rate']);

  flex.cellEditEnded.addHandler((s, e) => {
    const row = s.rows[e.row];
    const col = s.columns[e.col];
    const binding = col.binding;

    if (!row || !row.hasChildren || !bindingsToCascade.has(binding)) {
      return;
    }

    const value = row.dataItem[binding];

    updateChildren(
      row.dataItem,
      row.level,
      s.childItemsPath,
      binding,
      value
    );

    s.collectionView.refresh();
  });
}

function updateChildren(item, level, paths, binding, value) {
  const childPath = paths[Math.min(level, paths.length - 1)];
  const children = item[childPath];

  if (!Array.isArray(children)) {
    return;
  }

  children.forEach((child) => {
    child[binding] = value;
    updateChildren(child, level + 1, paths, binding, value);
  });
}
  • Use this when a parent row edit should push the edited value down to its descendants. In this example, edits to hours and rate are cascaded.

 

Add row insertion helpers

function insertItem(mode) {
  if (!flexSheet.value) {
    return;
  }

  insertItemAtIndex(
    flexSheet.value,
    flexSheet.value.selection.row,
    mode,
    { name: 'newItem', hours: 5, rate: 5 }
  );
}

function insertItemAtIndex(grid, index, mode, newItem) {
  const row = grid.rows[index];

  if (!row) {
    return;
  }

  if (mode === 'child') {
    const item = row.dataItem;
    const binding = grid.childItemsPath[
      Math.min(row.level, grid.childItemsPath.length - 1)
    ];

    if (!Array.isArray(item[binding])) {
      item[binding] = [];
    }

    item[binding].unshift(newItem);
  } else {
    const parentCollection = getParentCollection(grid, row.index);
    const itemIndex = parentCollection.indexOf(row.dataItem);
    const delta = mode === 'above' ? 0 : 1;

    parentCollection.splice(itemIndex + delta, 0, newItem);
  }

  grid.collectionView.refresh();
}

function getParentCollection(grid, rowIndex) {
  const row = grid.rows[rowIndex];

  if (row.level === 0) {
    return grid.collectionView.sourceCollection;
  }

  for (let r = rowIndex - 1; r >= 0; r--) {
    const parentRow = grid.rows[r];

    if (parentRow.hasChildren && parentRow.level < row.level) {
      return parentRow.dataItem[grid.childItemsPath[parentRow.level]];
    }
  }

  return grid.collectionView.sourceCollection;
}
  • These helpers allow users to add rows above, below, or as children of the selected row while keeping the nested source collection synchronized.

 

Add sample data and styles

function getSampleData() {
  return [
    {
      name: 'Jack Smith',
      checks: [
        {
          name: 'check1',
          earnings: [
            { name: 'hourly', hours: 30, rate: 15 },
            { name: 'overtime', hours: 10, rate: 20 },
            { name: 'bonus', hours: 5, rate: 30 }
          ]
        },
        {
          name: 'check2',
          earnings: [
            { name: 'hourly', hours: 20, rate: 18 },
            { name: 'overtime', hours: 20, rate: 24 }
          ]
        }
      ]
    }
  ];
}
.toolbar {
  margin-bottom: 8px;
}

.toolbar button {
  margin-right: 6px;
}

.wj-flexsheet {
  height: 500px;
}

.wj-grouppanel .wj-remove {
  display: none;
}

 

With this setup, Vue FlexSheet can display nested data, allow edits on group rows, preserve formula display behavior, and update child rows from parent edits when needed.

Happy coding!

Andrew Peterson

Technical Engagement Engineer